#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <Performer/pf/pfChannel.h>
#include <Performer/pf/pfLightSource.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pfdu.h>
#include <pfcave.h>
#include "simpleNavigator.h"
#include "bounceDCS.h"

static void createScene(pfChannel *chan,int argc,char **argv);
static pfNode * animatedObject(char *file);


int main(int argc,char **argv)
{
 pfInit();
 simpleNavigator::init();
 bounceDCS::init();
 pfCAVEConfig(&argc,argv,NULL);
 pfConfig();
 pfCAVEInitChannels();
 if (CAVEConfig->Simulator)
	pfCAVEMasterChan()->getFStats()->setClass(
			PFSTATS_ALL^PFSTATSHW_ENGFXPIPE_FILL, PFSTATS_ON);
 else
	pfCAVEMasterChan()->getFStats()->setClass(PFSTATS_ALL, PFSTATS_OFF);
 createScene(pfCAVEMasterChan(),argc,argv);
 while (!CAVEgetbutton(CAVE_ESCKEY))
	{
	pfSync();
	pfCAVEPreFrame();
	pfFrame();
	pfCAVEPostFrame();
	}
 CAVEHalt();
 pfExit();
 return 0;
}


/* createScene() - creates the scene.
*/
static void createScene(pfChannel *chan,int argc,char **argv)
{
 pfScene *scene;
 pfGeoState *gstate;
 simpleNavigator *nav;
 scene = new pfScene;
 gstate = new pfGeoState;
 gstate->setMode(PFSTATE_ENLIGHTING, PF_ON);
 gstate->setMode(PFSTATE_CULLFACE, PFCF_OFF);
 scene->setGState(gstate);
 scene->addChild(new pfLightSource);
 nav = new simpleNavigator;
 scene->addChild(nav);
 if (argc > 1)
	nav->addChild(animatedObject(argv[1]));
 if (argc > 2)
	nav->addChild(pfdLoadFile(argv[2]));
 chan->setScene(scene);
}


static pfNode * animatedObject(char *file)
{
 pfNode *obj;
 bounceDCS *dcs;
 obj = pfdLoadFile(file);
 if (!obj)
	pfExit();
 dcs = new bounceDCS;
 dcs->setPosition(0, 4, 5);
 dcs->setVelocity(-0.4, 0.3, 0);
 dcs->addChild(obj);
 return dcs;
}
