#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <Performer/pf/pfChannel.h>
#include <Performer/pf/pfLightSource.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pfdu.h>
#include <pfcave.h>
#include "simpleNavigator.h"
#include "gravDCS.h"

static void createScene(pfChannel *chan,int argc,char **argv);
static void loadObjects(int argc,char **argv,pfGroup *parent);
static int grabTest(pfTraverser *trav,void *);


static int buttonChange=0;


int main(int argc,char **argv)
{
 pfInit();
 simpleNavigator::init();
 gravDCS::init();
 pfCAVEConfig(&argc,argv,NULL);
 pfConfig();
 pfCAVEInitChannels();
 if (CAVEConfig->Simulator)
	pfCAVEMasterChan()->getFStats()->setClass(
			PFSTATS_ALL^PFSTATSHW_ENGFXPIPE_FILL, PFSTATS_ON);
 else
	pfCAVEMasterChan()->getFStats()->setClass(PFSTATS_ALL, PFSTATS_OFF);
 createScene(pfCAVEMasterChan(),argc,argv);
 while (!CAVEgetbutton(CAVE_ESCKEY))
	{
	buttonChange = CAVEButtonChange(2);
	pfSync();
	pfCAVEPreFrame();
	pfFrame();
	pfCAVEPostFrame();
	}
 CAVEHalt();
 pfExit();
 return 0;
}


static void createScene(pfChannel *chan,int argc,char **argv)
{
 pfScene *scene;
 pfGeoState *gstate;
 simpleNavigator *nav;
 scene = new pfScene;
 gstate = new pfGeoState;
 gstate->setMode(PFSTATE_ENLIGHTING, PF_ON);
 gstate->setMode(PFSTATE_CULLFACE, PFCF_OFF);
 scene->setGState(gstate);
 scene->addChild(new pfLightSource);
 nav = new simpleNavigator;
 scene->addChild(nav);
 loadObjects(argc,argv,nav);
 chan->setScene(scene);
}


static void loadObjects(int argc,char **argv,pfGroup *parent)
{
 int i;
 pfNode *obj;
 for (i=1; i<argc; i++)
	{
	obj = pfdLoadFile(argv[i]);
	if (obj)
		{
		gravDCS *g = new gravDCS;
		g->setPosition(drand48()*10.0f-5.0f, drand48()*5.0f, 3.0f);
		g->setTravFuncs(PFTRAV_APP, grabTest, NULL);
		g->addChild(obj);
		parent->addChild(g);
		}
	else
		pfExit();
	}
}

static int grabTest(pfTraverser *trav,void *)
{
 if (buttonChange == 1)
	{
	grabberDCS *g = (grabberDCS *) trav->getNode();
	if (g->isGrabbed())
		g->release();
	else
		{
		pfSphere boundSphere;
		pfVec3 wandPos;
		g->getBound(&boundSphere);
		CAVEGetPosition(CAVE_WAND_NAV, wandPos.vec);
		if (boundSphere.contains(wandPos))
			g->grab();
		}
	}
 return PFTRAV_CONT;
}
