#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <Performer/pf/pfChannel.h>
#include <Performer/pf/pfLightSource.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pfdu.h>
#include <pfcave.h>
#include "simpleNavigator.h"

static void createScene(pfChannel *chan,int argc,char **argv);
static void loadObjects(int argc,char **argv,pfGroup *parent);


/* main() - this is identical to the skeleton main of outline.c++,
	except for the call to simplNavigator::init().  All subclasses
	of Performer classes must be initialized like this after pfInit(). */
int main(int argc,char **argv)
{
 pfInit();
 simpleNavigator::init();
 pfCAVEConfig(&argc,argv,NULL);
 pfConfig();
 pfCAVEInitChannels();
 if (CAVEConfig->Simulator)
	pfCAVEMasterChan()->getFStats()->setClass(
			PFSTATS_ALL^PFSTATSHW_ENGFXPIPE_FILL, PFSTATS_ON);
 else
	pfCAVEMasterChan()->getFStats()->setClass(PFSTATS_ALL, PFSTATS_OFF);
 createScene(pfCAVEMasterChan(),argc,argv);
 while (!CAVEgetbutton(CAVE_ESCKEY))
	{
	pfSync();
	pfCAVEPreFrame();
	pfFrame();
	pfCAVEPostFrame();
	}
 CAVEHalt();
 pfExit();
 return 0;
}


/* createScene() - creates the scene.  This is the same as in navobj.c++,
	except that a simpleNavigator node is used in place of the DCS
	for navigation.
*/
static void createScene(pfChannel *chan,int argc,char **argv)
{
 pfScene *scene;
 pfGeoState *gstate;
 simpleNavigator *nav;
 scene = new pfScene;
 gstate = new pfGeoState;
 gstate->setMode(PFSTATE_ENLIGHTING, PF_ON);
 gstate->setMode(PFSTATE_CULLFACE, PFCF_OFF);
 scene->setGState(gstate);
 scene->addChild(new pfLightSource);
 nav = new simpleNavigator;		/* Create the navigator & add it to the scene */
 scene->addChild(nav);
 loadObjects(argc,argv,nav);
 chan->setScene(scene);
}


static void loadObjects(int argc,char **argv,pfGroup *parent)
{
 int i;
 pfNode *obj;
 for (i=1; i<argc; i++)
	{
	obj = pfdLoadFile(argv[i]);
	if (obj)
		parent->addChild(obj);
	else
		pfExit();
	}
}
