#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <Performer/pf/pfChannel.h>
#include <Performer/pf/pfLightSource.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pfdu.h>
#include <pfcave.h>
#include "simpleNavigator.h"
#include "bullet.h"


static void createScene(pfChannel *chan,int argc,char **argv);
static void loadObjects(int argc,char **argv,pfGroup *parent);
static int checkForShoot(pfTraverser *trav,void *data);


int main(int argc,char **argv)
{
 pfInit();
 simpleNavigator::init();
 bullet::init();
 pfCAVEConfig(&argc,argv,NULL);
 CAVEFar = 1000;
 pfConfig();
 pfCAVEInitChannels();
 if (CAVEConfig->Simulator)
	pfCAVEMasterChan()->getFStats()->setClass(
			PFSTATS_ALL^PFSTATSHW_ENGFXPIPE_FILL, PFSTATS_ON);
 else
	pfCAVEMasterChan()->getFStats()->setClass(PFSTATS_ALL, PFSTATS_OFF);
 createScene(pfCAVEMasterChan(),argc,argv);
 while (!CAVEgetbutton(CAVE_ESCKEY))
	{
	pfSync();
	pfCAVEPreFrame();
	pfFrame();
	pfCAVEPostFrame();
	}
 CAVEHalt();
 pfExit();
 return 0;
}


static int checkForShoot(pfTraverser *trav,void *)
{
 if (CAVEButtonChange(1) == 1)
	{
	pfGroup *group = (pfGroup *) trav->getNode();
	bullet *b = new bullet;
	b->setWorld(group);
	group->addChild(b);
	}
 return PFTRAV_CONT;
}


static void createScene(pfChannel *chan,int argc,char **argv)
{
 pfScene *scene;
 pfGeoState *gstate;
 simpleNavigator *nav;
 pfGroup *world;
 pfLightSource *light;
 scene = new pfScene;
 gstate = new pfGeoState;
 gstate->setMode(PFSTATE_ENLIGHTING, PF_ON);
 gstate->setMode(PFSTATE_CULLFACE, PFCF_OFF);
 scene->setGState(gstate);
 scene->addChild(new pfLightSource);
 light = new pfLightSource;
 light->setPos(0.5,-1.0,1.0,0.0);
 light->setColor(PFLT_DIFFUSE,0.5,0.5,0.5);
 light->setAmbient(0.3,0.3,0.3);
 scene->addChild(light);
 nav = new simpleNavigator;
 scene->addChild(nav);
 world = new pfGroup;
 nav->addChild(world);
 world->setTravFuncs(PFTRAV_APP,checkForShoot,NULL);
 loadObjects(argc,argv,world);
 scene->setTravMask(PFTRAV_ISECT, 0xffffffff,
			PFTRAV_SELF|PFTRAV_DESCEND|PFTRAV_IS_CACHE, PF_OR);
 chan->setScene(scene);
}


static void loadObjects(int argc,char **argv,pfGroup *parent)
{
 int i;
 pfNode *obj;
 for (i=1; i<argc; i++)
	{
	obj = pfdLoadFile(argv[i]);
	if (obj)
		parent->addChild(obj);
	else
		pfExit();
	}
}
